
! ***** This is level 1 program *****

! This program requires shift communication 

      PROGRAM MAIN 
      REAL X(0:15), Y(0:15) 
!HPF$ PROCESSORS P(2) 
!HPF$ TEMPLATE TX(0:15),TY(0:15) 
!HPF$ DISTRIBUTE TX(BLOCK) ONTO P 
!HPF$ DISTRIBUTE TY(BLOCK) ONTO P 
!HPF$ ALIGN X(i) WITH TX(i) 
!HPF$ ALIGN Y(i) WITH TY(15 - i) 

      FORALL (i=0:15) X(i) = 0 
      FORALL (i=0:15) Y(i) = i 
      FORALL (i=7:12) X(i) = Y((-1) * i + 19) + Y((-1) * i + 20) 

      PRINT 111, (X(i),i=0,15) 
111   FORMAT(1x,f17.2) 
      END 
